package com.gxwebsoft.tower.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.tower.service.TowerWarehouseService;
import com.gxwebsoft.tower.entity.TowerWarehouse;
import com.gxwebsoft.tower.param.TowerWarehouseParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 仓库管理控制器
 *
 * @author 科技小王子
 * @since 2023-05-20 15:06:43
 */
@Api(tags = "仓库管理管理")
@RestController
@RequestMapping("/api/tower/tower-warehouse")
public class TowerWarehouseController extends BaseController {
    @Resource
    private TowerWarehouseService towerWarehouseService;

    @PreAuthorize("hasAuthority('tower:towerWarehouse:list')")
    @OperationLog
    @ApiOperation("分页查询仓库管理")
    @GetMapping("/page")
    public ApiResult<PageResult<TowerWarehouse>> page(TowerWarehouseParam param) {
        // 使用关联查询
        return success(towerWarehouseService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerWarehouse:list')")
    @OperationLog
    @ApiOperation("查询全部仓库管理")
    @GetMapping()
    public ApiResult<List<TowerWarehouse>> list(TowerWarehouseParam param) {
        // 使用关联查询
        return success(towerWarehouseService.listRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerWarehouse:list')")
    @OperationLog
    @ApiOperation("根据id查询仓库管理")
    @GetMapping("/{id}")
    public ApiResult<TowerWarehouse> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(towerWarehouseService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('tower:towerWarehouse:save')")
    @OperationLog
    @ApiOperation("添加仓库管理")
    @PostMapping()
    public ApiResult<?> save(@RequestBody TowerWarehouse towerWarehouse) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          towerWarehouse.setUserId(loginUser.getUserId());
        }
        if (towerWarehouseService.save(towerWarehouse)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerWarehouse:update')")
    @OperationLog
    @ApiOperation("修改仓库管理")
    @PutMapping()
    public ApiResult<?> update(@RequestBody TowerWarehouse towerWarehouse) {
        if (towerWarehouseService.updateById(towerWarehouse)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerWarehouse:remove')")
    @OperationLog
    @ApiOperation("删除仓库管理")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (towerWarehouseService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('tower:towerWarehouse:save')")
    @OperationLog
    @ApiOperation("批量添加仓库管理")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<TowerWarehouse> list) {
        if (towerWarehouseService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerWarehouse:update')")
    @OperationLog
    @ApiOperation("批量修改仓库管理")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<TowerWarehouse> batchParam) {
        if (batchParam.update(towerWarehouseService, "warehouse_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerWarehouse:remove')")
    @OperationLog
    @ApiOperation("批量删除仓库管理")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (towerWarehouseService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
